Subject: RE: [AAA-WG]: Issue 365: Revised Extensibility Section

From: "Harri Hakala (LMF)" <[email-masked]>
Date: Thu, 12 Sep 2002 09:53:07 +0200

> 1.2.4 Creating New Accounting Applications
> 
> There are services that only require Diameter accounting.
> Such services need to define the AVPs carried in the ACR/ACA messages,
> but do not need to define new command codes. An implementation MAY add
> arbitrary non-mandatory AVPs (e.g. AVPs with the "M" bit not 
> set) to any
> command defined in an application, including vendor-specific
> AVPs, without needing to define a new accounting application. Please
> refer to section 11.1.1 for details.
> 
> Application Identifiers are still required for Diameter capability
> exchange. Every accounting application MUST have either an IANA
> allocated Application Identifier, or a vendor specific Application
> Identifier.
> 
> Since every Diameter implementation MUST support accounting, there
> is no need to advertise support for the Base accounting application
> within the CER/CEA, since this is implicit. This basic accounting
> support is sufficient to handle any application that uses the
> ACR/ACA commands defined in this document, as long as no new
> mandatory AVPs are added. A mandatory AVP is defined as one
> which has the "M" bit set when sent within an accounting command,
> regardless of whether it is required or optional within the ABNF for
> the accounting application.

Should here be mentioned also that if the basic accounting is used
without any mandatory AVPs or new commands, then the base protocol defined
standard accounting application Id (section 2.4) must be used in ACR/ACA
commands.

.....
Section 2.4 Application Identifiers

Standard accounting   X
.....

/ Harri

---

From: Bernard Aboba <[email-masked]>
Date: Thu, 12 Sep 2002 04:49:11 -0700 (PDT)

> standard accounting application Id (section 2.4) must be used in ACR/ACA

Yes. Have added the following text to the recommended changes for #365:

"The creation of a new accounting application should be viewed as a
last resort and MUST NOT be used unless a new command is defined with
the application, or new mandatory AVPs are added to the ABNF. If
a Diameter accounting application requires no new mandatory AVPs
and no new commands (only ACR/ACA are used), then the standard
accounting application Id (section 2.4) MUST be used in ACR/ACA commands."

---

From: Yoshihiro Ohba <[email-masked]>
Date: Mon, 16 Sep 2002 09:57:59 -0400

In order for parser dictionary to deal with the case in which new
mandatory AVPs for ACR/ACA commands are added to the ABNF with a new
application Id, I think the ABNF should include application-id as well
as comomand-id.  Otherwise, it would be difficult to handle the case
where some of the mandatory AVPs are required part of the commands.
So I would like to request for changing the Command Code ABNF
specification as follows:

      header           = "<" Diameter-Header:" command-id application-id
                         [r-bit] [p-bit] [e-bit] ">"

      command-id       = 1*DIGIT
                         ; The Command Code assigned to the command

      application-id   = 1*DIGIT
                         ; The Application Id used for the command

What do you think?

Yoshihiro Ohba